
function aiNewDetectedWallIds = CalculateInternalBorders( atDrones, tEnvironment)
    aiPreviousDetectedWalls = Drone.GetDetectedWallIds(atDrones);
    % assume same communication and detect range for everybody
    % this is easy to generalize later
    fComRange = 2*atDrones(1).tSensor.Range(2);
    for iDrone = 1:numel(atDrones)
        atDrones(iDrone).aafInternalBorders = [];
        atDrones(iDrone).CalculateWallBorders(tEnvironment);
    end
    
    for iDrone = 1:numel(atDrones)
        for iOtherDrone = iDrone+1:numel(atDrones)
            if sum((atDrones(iDrone).afState(1:2)-atDrones(iOtherDrone).afState(1:2)).^2) ...
                    < fComRange^2
                [afAnglesDrone, afAnglesOtherDrone] = ...
                    CircleIntersection(atDrones(iDrone).afState(1:2), ...
                    atDrones(iOtherDrone).afState(1:2), fComRange/2);
                atDrones(iDrone).aafInternalBorders(end+1,:) = afAnglesDrone;
                    
                atDrones(iOtherDrone).aafInternalBorders(end+1,:) = afAnglesOtherDrone;
            end %end if
        end
    end
    for iDrone = 1:numel(atDrones)
        atDrones(iDrone).aafInternalBorders = sortrows(atDrones(iDrone).aafInternalBorders);
    end
    
    aiDetectedWalls = Drone.GetDetectedWallIds(atDrones);
    aiNewDetectedWallIds = aiDetectedWalls(~ismember(aiDetectedWalls, aiPreviousDetectedWalls));
end

function [afAngles1, afAngles2] = CircleIntersection(afCenter1, afCenter2, fRad)
    fDeltaX = afCenter2(1) - afCenter1(1);
    fDeltaY = afCenter2(2) - afCenter1(2);
    fDistance = sqrt(fDeltaX^2 + fDeltaY^2);
    fXIntersect = fDistance/2;
    
    fLocalAngle = acos(fXIntersect/fRad);
    fCenterAngle = atan2(fDeltaY, fDeltaX);
    
    
    afAngles1 = [fCenterAngle - fLocalAngle, fCenterAngle + fLocalAngle];
    afAngles2 = afAngles1(1,:)+pi;
    
    afAngles1 = wrapTo2Pi(afAngles1);
    afAngles2 = wrapTo2Pi(afAngles2);
        
end
