
function CalculateWallBorders(tDrone, tEnvironment)
    tDrone.aafWallAngles = [];
    afPose = [tDrone.afState(1:2)' 0];
    [afRanges, afAngles] = tDrone.tSensor(afPose,tEnvironment.tMap);
    
%     for iAngle = 1:numel(afAngles)
%         if isnan(afRanges(iAngle)) %if we dont spot a wall
%             afRanges(iAngle) = tDrone.tSensor.Range(2);
%         end
%     end
            
    bAtWall = false;
    for iAngle = 1:numel(afAngles)
        if ~isnan(afRanges(iAngle)) %if we spot a wall
            if bAtWall == false %if this is new wall registrate start angle
                fTheta1 = afAngles(iAngle);
                bAtWall = true;
            end
        else %else spotting no wall
            afRanges(iAngle) = tDrone.tSensor.Range(2);
            if bAtWall == true %if we were at wall, registrate end angle
                fTheta2 = afAngles(iAngle);
                tDrone.aafWallAngles(end+1,:) = [fTheta1, fTheta2];
                bAtWall = false;
            end
        end
    end % end for iAngle
    if bAtWall == true
        fTheta2 = afAngles(iAngle);
        tDrone.aafWallAngles(end+1,:) = [fTheta1, fTheta2];
    end
    tDrone.afSensorReading = afRanges;
    
    
    
%     for iWall = 1:size(tEnvironment.aaiWalls,1)
%         in = LineInsideCircle(tEnvironment.aaiWalls(iWall,1:4), ...
%             tDrone.afState(1:2), tDrone.tSensor.Range(2));
%         if ~isempty(in)
%             fTheta1 = atan2(in(1,2)-tDrone.afState(2), in(1,1) - tDrone.afState(1));
%             fTheta2 = atan2(in(2,2)-tDrone.afState(2), in(2,1) - tDrone.afState(1));
%             [fTheta1, fTheta2] = OrderAngles(fTheta1, fTheta2);
%             tDrone.aafWallAngles(end+1,:) = [fTheta1, fTheta2];
%             %tDrone.aiWallIds(tEnvironment.aaiWalls(iWall,5)) = 1;
%         end
%     end
    
end

function [fSmallestAngle, fBiggestAngle] = OrderAngles(fTheta1, fTheta2)
    fDiff = angdiff(fTheta1, fTheta2);
    if fDiff > 0
        fSmallestAngle = fTheta1;
        fBiggestAngle = fTheta2;
    else
        fBiggestAngle = fTheta1;
        fSmallestAngle = fTheta2;
    end
    fSmallestAngle = wrapTo2Pi(fSmallestAngle);
    fBiggestAngle = wrapTo2Pi(fBiggestAngle);
    
end

function aafInsidePoints = LineInsideCircle(afLine, afCircleCenter, fCircleRad)
    % line: [x1 y1 x2 y2];
    % function parameterizes the line by x = x2 + t*(x1-x2), same for y and
    % substitue in the formula for circle (x-x_c)^2 + (y-y_c)^2 = R^2. Then
    % solve for t and check if it is within the line
    % Output: line segment within the circle [x1 y1;x2 y2];
    A = (afLine(1) - afLine(3))^2 + (afLine(2)-afLine(4))^2;
    B = 2*((afLine(1)-afLine(3))*(afLine(3)-afCircleCenter(1)) + ...
        (afLine(2)-afLine(4))*(afLine(4)-afCircleCenter(2)));
    C = (afLine(3)-afCircleCenter(1))^2 + (afLine(4)-afCircleCenter(2))^2 - fCircleRad^2;
    det = B^2 - 4*A*C;

    if det > 0
        t1 = (-B + sqrt(det))/(2*A);
        t2 = (-B - sqrt(det))/(2*A);
        if (t1 < 1 && t1 > 0) || (t2 < 1 && t2 > 0)
            if t1 > 1
                t1 = 1;
            elseif t1 < 0
                t1 = 0;
            end
            x1Intersect = afLine(3) + t1*(afLine(1)-afLine(3));
            y1Intersect = afLine(4) + t1*(afLine(2)-afLine(4));

            if t2 > 1
                t2 = 1;
            elseif t2 < 0
                t2 = 0;
            end
            x2Intersect = afLine(3) + t2*(afLine(1)-afLine(3));
            y2Intersect = afLine(4) + t2*(afLine(2)-afLine(4));
            aafInsidePoints = [x1Intersect y1Intersect; x2Intersect y2Intersect];
        else
            aafInsidePoints = [];
        end
    else
        aafInsidePoints = [];
    end
    
end


