classdef Drone < handle
    
    properties
        tDynamics           % model of the dynamics
        fMaxVel             % Max Velocity 
        fMaxAcc             % Max velocity change between two time steps
        afState             % [posx; posy; velx; vely]
        tSensorParam        % struct containing sensor params
        afSensorReading     % Range bearing sensor
        
        aafInternalBorders  % each row is a border with [theta1,theta2]
                            % which defines angles a border crosses the
                            % circle
%         aafWallBorders      % [x1 y1 x2 y2]
        aafWallAngles       % theta1 theta2git igi
        
        tSensor
        aiWallIds
    end

    
    methods
        function atDrones = Drone( iNumberOfDrones )
            if( nargin > 0 )
                atDrones(iNumberOfDrones).afState		= [];
                atDrones(iNumberOfDrones).tDynamics		= [];
				
            else
                atDrones.afState            = [];
                atDrones.tDynamics			= [];
                
            end
            
        end %Constructor
    end
    
    methods(Static = true)
        bFailed = Init(atDrones, iNumberOfDrones, aafInitPos, ... 
            fMaxAcc, fMaxVel, tDynamics, tSensorParam, tSensor);
        aafMeasurements = UpdateMeasurements( atDrones, tEnvironment );
        aafNewPoses = ActuateAll( atDrones, aafInput, fTimestep );
        atAfterAddingDrones = EnterNewDrone(atDrones, ...
            iNumberOfNewDrones, aafPoses);
        aafPredictedStates = PredictAll(atDrones, aafInitStates, aafInputs, fTimestep);
        atCopiedDrones = CopyAll(atOriginalDrones);
        aiNewDetectedWallIds = CalculateInternalBorders( atDrones , tEnvironment);
        Plot(atDrones, tMap, iFigureNumber);
        aiAllWallIds = GetDetectedWallIds( atDrones )
    end
end