
function aafFreeAngles = GetFreeAngles(tDrone)
    
    if numel(tDrone.aafInternalBorders) == 0 && numel(tDrone.aafWallAngles) == 0
        aafFreeAngles = [0 2*pi];
    else
        aafOccupiedAngles = MergeAngles([tDrone.aafInternalBorders; tDrone.aafWallAngles]);
        aafFreeAngles = [];
        for iAngle = 1:size(aafOccupiedAngles)-1
            aafFreeAngles(end + 1,:) = [aafOccupiedAngles(iAngle,2), ...
                aafOccupiedAngles(iAngle+1,1)]; 
        end
        if ~all([aafOccupiedAngles(1,1) aafOccupiedAngles(end,2)] == [0 2*pi])
            aafFreeAngles(end+1,:) = [aafOccupiedAngles(end,2), aafOccupiedAngles(1,1)];
        end
            
    end
end

function aafOccupiedAngles = MergeAngles(aafAngles)
    
    aafSplittedAngles = aafAngles;
    for iAngle = 1:size(aafAngles)
        if aafAngles(iAngle,1) > aafAngles(iAngle,2)
            aafSplittedAngles(end+1,1:2) = [aafAngles(iAngle,1) 2*pi];
            aafSplittedAngles(iAngle,1) = 0;
        end
    end
    
    aafSplittedAngles = sortrows(aafSplittedAngles);
    aafOccupiedAngles = aafSplittedAngles(1,:);
    
    for iAngle = 1:size(aafSplittedAngles)-1
        
        if aafOccupiedAngles(end,2) >= aafSplittedAngles(iAngle+1,1)
            if aafOccupiedAngles(end,2) >= aafSplittedAngles(iAngle+1,2)
                continue;
            else
                aafOccupiedAngles(end,2) = aafSplittedAngles(iAngle+1,2);
            end
        else
            aafOccupiedAngles(end+1,:) = aafSplittedAngles(iAngle+1,:);
        end
    end
    
end
