


function aftSensorReading = GetWallMeasurements(tDrone, tEnvironment)

    afAngles = tDrone.tSensorParam.afAngles;
    
    aftSensorReading = tDrone.tSensorParam.fRange*ones(numel(afAngles),1); 
    for iAngle = 1:numel(afAngles)
        
        bReadingAtThisAngle = 0; 
        for iRange = tDrone.tSensorParam.afRanges'
            
            % finds the position of the sensing with respect to the environment 
            afSensPos = [tDrone.afState(1) + cos(afAngles(iAngle))*iRange; tDrone.afState(2) + sin(afAngles(iAngle))*iRange];
            
            % for every existing wall, check if we are close on one of the
            % axis, and then check the other axis accordingly
            for iWall = 1:size(tEnvironment.aaiWalls,1)   
                if isWallAtPos(afSensPos,tEnvironment.aaiWalls(iWall,:), tDrone.tSensorParam.fDeltaRange/2)
                    aftSensorReading(iAngle) = iRange;
                    bReadingAtThisAngle = 1;
                    break;
                end    
            end % end for iWall
            if bReadingAtThisAngle == 1
                break;
            end
        end % end for iRange 
    end % end for iAngle
    
end


function bWallAtPos = isWallAtPos(afPos, aiWall, fEpsilon)
    if abs(aiWall(1) - afPos(1)) <= fEpsilon && ...
        afPos(2) <= aiWall(4) && afPos(2) >= aiWall(3)
        
        bWallAtPos = 1;
    elseif abs(aiWall(3) - afPos(2)) <= fEpsilon && ...
        afPos(1) <= aiWall(2) && afPos(1) >= aiWall(1)
        
        bWallAtPos = 1;
    else
        bWallAtPos = 0;
    end
end