

function Plot(atDrones, tMap, iFigureNumber)

    switch( nargin )
        case 1
            iFigureNumber = 20;
            iNumberOfDrones = 0;
        case 2
            iNumberOfDrones = numel(atDrones);
            iFigureNumber = 20;
        case 3
            iNumberOfDrones = numel(atDrones);
    end
                
    figure( iFigureNumber )
    clf;
    hold on;
    
    show(tMap);
    
    th = 0:pi/40:2*pi;
    for iDrone = 1:iNumberOfDrones
        scatter( atDrones(iDrone).afState(1), atDrones(iDrone).afState(2));
        xunit = atDrones(iDrone).tSensorParam.fRange* cos(th) + atDrones(iDrone).afState(1);
        yunit = atDrones(iDrone).tSensorParam.fRange* sin(th) + atDrones(iDrone).afState(2);
        plot(xunit, yunit, 'Color', 'r');
    end
    hold off;

end