

function fArea = AreaCovered(tEnvironment, atDrones)

    fArea = 0;
    for iDrone = 1:numel(atDrones)

        afSensorReadings = atDrones(iDrone).GetWallMeasurements(tEnvironment);
        
        % integral of sensing disk as a reimeann sum
        fArea = fArea + 1/2 * atDrones(iDrone).tSensorParam.fDeltaAngle* ...
            afSensorReadings'*afSensorReadings;

        % if sensing area of drones overlap -> subtract intersecting area
        for iOtherDrone = iDrone+1:numel(atDrones)
            if sum((atDrones(iDrone).afState(1:2)-atDrones(iOtherDrone).afState(1:2)).^2) < atDrones(iDrone).tSensorParam.fRange^2
                fArea = fArea - CircleIntersection(atDrones(iDrone).afState(1:2), atDrones(iDrone).tSensorParam.fRange, ...
                                                   atDrones(iOtherDrone).afState(1:2), atDrones(iOtherDrone).tSensorParam.fRange);
            end
            
        end % end for iOtherDrone
          
    end % end for iDrone

end

% Ref thesis for the formula
% Now doing shortcut when knowing the radius are the same
function fIntersectedArea = CircleIntersection(afCenter1, fRad1, afCenter2, fRad2)
    fDistance = sqrt((afCenter1(1) - afCenter2(1))^2 ...
                    + (afCenter1(2) - afCenter2(2))^2);
    fXIntersect = fDistance/2;
    fYIntersect = sqrt(fRad1^2 - fXIntersect^2);
    
    fSector = fRad1^2*asin(fYIntersect/fRad1);
    fTriangle = fYIntersect*fXIntersect;
    
    fIntersectedArea = 2*(fSector - fTriangle);


end