function model = DroneModelSecondOrder(m, nu)
    % returns a structure that implements the continuous model for the
    % drones. 

    model.f = @(x,u) [x(3:4); -nu/m *x(3:4)] + ...
        [zeros(2,1); 1/m*u(1:2)];
    model.A = [0 0 1 0;
                0 0 0 1;
                0 0 -nu/m 0;
                0 0 0 -nu/m];
    model.B = [0;
                0;
                1/m;
                1/m];

end