
function EstimationMovie(sRoomType, sRatio, sControlType, sEnterancePoint, sNumberOfDronePerEnter, ...
    tEnvironment, aaafDronePoses, fRange, afTotalArea)

    close all;

    %---------Params-------
    iTime = numel(afTotalArea);
    iNumberOfDrones = size(aaafDronePoses,2);

    plotInterval = 10;  % interval between states to print
    plotRange = 1:plotInterval:iTime; % the range to go through
    plotpause = 0.1; %seconds/size(plotRange,2); % lenght to pause between time steps;

    bSaveVideo = false;
    sLocation = '../Results';
    sMethod = strcat('/',sRoomType,'_',sRatio,'_',sControlType,'_',sEnterancePoint,'_',sNumberOfDronePerEnter,'_',int2str(fRange)); 
    sVideoName = strcat(sLocation, sMethod,'/movie.avi');
    
    if exist(sVideoName)
        return;
    end
    
    figure;  hold on;
    %ax = gca;
    th = 0:pi/50:2*pi;


    %axis tight manual
    %set(gca, 'nextplot','replacechildren');


    if bSaveVideo
        v = VideoWriter(sVideoName);
        v.FrameRate = 5;
        open(v);
    end

    for i = plotRange

        subplot(2,1,1);
        % plot walls
        show(tEnvironment.tMap);
        hold on;

        for node = 1:iNumberOfDrones

            scatter(aaafDronePoses(1, node,i),aaafDronePoses(2, node,i));

            xunit = fRange * cos(th) + aaafDronePoses(1, node, i);
            yunit = fRange * sin(th) + aaafDronePoses(2, node, i);
            plot(xunit, yunit);
        end
        hold off;

        subplot(2,1,2);
        plot([1:i], afTotalArea(1:i)/tEnvironment.fArea*100);
        xlabel('timesteps');
        title('area covered as percent of full environment');
        grid on;
        axis([0 iTime 0 100]);

        if bSaveVideo
            frame = getframe(gcf);
            writeVideo(v,frame);
        end

        pause(plotpause)
        hold off;
    end
    if bSaveVideo
        close(v);
    end
end
