function InnerBorders(atDrones, tEnvironment)
    Drone.CalculateBorders(atDrones, tEnvironment);
    fRange = atDrones(1).tSensorParam.fRange;
    for iDrone = 1:numel(atDrones)
        for iNewLine = 1:size(atDrones(iDrone).aafBorders2,1)
            
            bNoCross = true;
            for iExistingLine = 1:size(atDrones(iDrone).aafRealBorders,1)
                [afPoint, t12, t13] = LineIntersect(atDrones(iDrone).aafBorders2(iNewLine), ...
                    atDrones(iDrone).aafBorders2(iExistingLine));
                if sum((atDrones(iDrone).afState(1:2) - ...
                    afPoint').^2) < (2*atDrones(1).tSensorParam.fRange)^2
       
                end
            atDrones(DT.ConnectivityList(iRow,1)).aafBorders2(end+1,:) = ...
                [afPoint, t12*afLine12(3:4), t13*afLine13(3:4)]; 
            atDrones(DT.ConnectivityList(iRow,2)).aafBorders2(end+1,:) = ...
                [afPoint, t12*afLine12(3:4), t23*afLine23(3:4)]; 
            atDrones(DT.ConnectivityList(iRow,3)).aafBorders2(end+1,:) = ...
                [afPoint, t13*afLine13(3:4), t23*afLine23(3:4)]; 
                
                
            end %end for otherLine
            
            aafCrossPoints = LineCrossCircle(atDrones(iDrone).aafBorders2(iNewLine), ...
                atDrones(iDrone).afState(1:2), fRange);
            atDrones(iDrone).aafRealBorders(end+1,:) = [aafCrossPoints(1,:), aafCrossPoints(2,:)];
        end
    end
    
end

function [afPoint, t1, t2] = LineIntersect(afLine1, afLine2)
    % lines given by [line(1); line(2)] + t*[line(3);line(4)];
    t2 = (afLine2(2) - afLine1(2) - afLine1(4)/afLine1(3)*(afLine2(1) - afLine1(1)))/...
        (afLine2(3)/afLine1(3)*afLine1(4) - afLine2(4));
    t1 = (afLine2(1) - afLine1(1) + t2*afLine2(3))/afLine1(3);
    afPoint = [afLine2(1) + t2*afLine2(3) afLine2(2) + t2*afLine2(4)];
    t2 = -t2;
    t1 = -t1;
end

function bOnLine = PointOnLine(afLine, afPoint1)
    t1 = (afPoint1(1) - afLine(1))/afLine(3);
    t2 = (afPoint1(2) - afLine(2))/afLine(4);
    bOnLine = t1==t2;
end

function aafCrossPoints = LineCrossCircle(afLine, afCircleCenter, fCircleRad)
    % line given by [line(1); line(2)] + t*[line(3);line(4)];
    A = afLine(3)^2 + afLine(4)^2;
    B = 2*(afLine(3)*(afLine(1)-afCircleCenter(1)) + ...
        afLine(4)*(afLine(2)-afCircleCenter(2)));
    C = (afLine(1)-afCircleCenter(1))^2 + (afLine(2)-afCircleCenter(2))^2 - fCircleRad^2;
    det = B^2 - 4*A*C;

    if det > 0
        t1 = (-B + sqrt(det))/(2*A);
        t2 = (-B - sqrt(det))/(2*A);
        if t1 <= 1 && t1 >= 0
            x1Intersect = afLine(2) + t1*(afLine(1)-afLine(2));
            y1Intersect = afLine(4) + t1*(afLine(3)-afLine(4));
        end
        if t2 <= 1 && t2 >= 0
            x2Intersect = afLine(2) + t2*(afLine(1)-afLine(2));
            y2Intersect = afLine(4) + t2*(afLine(3)-afLine(4));
        else
            breakpoint = true;
        end
        aafCrossPoints = [x1Intersect y1Intersect; x2Intersect y2Intersect];
    else
        aafCrossPoints = [];
    end
    
end