
function PlotAndSave(sRoomType, sRatio, sControlType, aEntrancePoint, sNumberOfDronePerEnter, sRange, ...
    afTotalArea, tEnvironment, atDrones, sGain)

    if aEntrancePoint == [2;0]
        sEntrancePoint = 'Corner';
    else 
        sEntrancePoint = 'Mid';
    end

    bSave = false;
    sLocation = '../Results_new';
    sMethod = strcat('/',sRoomType,'_',sControlType,'_',sEntrancePoint,'_',...
        sNumberOfDronePerEnter,'_',sRange); 

    %----- Plotting and saving
    close all; 

    if bSave == true
        sFolder = strcat(sLocation, sMethod);
        if ~exist(sFolder, 'dir')
           mkdir(sFolder)
        end
    end

    %--------Total area covered----------
    figure; hold on;
    grid on;
    plot(afTotalArea);
    plot([1 numel(afTotalArea)], [tEnvironment.fArea tEnvironment.fArea],'--');
    
    title('Total area covered');
    xlabel('Timesteps');
    ylabel('Area');
    if bSave
        saveas(gcf, strcat(sFolder, '/areaCovered.png'));
    end

    figure(10);
    title('Final position');
    tEnvironment.Plot(atDrones, 10);
    if bSave
        saveas(gcf, strcat(sFolder, '/finalPos.png'));
    end
    
    
end