close all;

%----Initialization
LoadParams;
savefile = '../Results_new/all_all_mid_all_all_fasterentry';

iRoomsizeX = 34;
iRoomsizeY = 34;
iPixelPerMeter = 10;

%---------Performance save----------
aaaaaaiTimeOfPercentageCoverage = zeros(20,size(csRoomTypes,2), size(csControlTypes,2), ...
    size(aafEntrancePoint,2), 4, numel(afDetectRange));

aaaaaaiNumberOfDrones = zeros(20,size(csRoomTypes,2), size(csControlTypes,2), ...
    size(aafEntrancePoint,2), 4, numel(afDetectRange));

aaaaaiFinalAreaCoverage = zeros(size(csRoomTypes,2), size(csControlTypes,2), ...
    size(aafEntrancePoint,2), 4, numel(afDetectRange));

tic

for iDetectRange = 1:numel(afDetectRange)
    for iController = 1:2
        for iEntrancePoint = 1:size(aafEntrancePoint,2)
            for iRoomType = 1:size(csRoom,2)    
                for iNewDrones = 1:4
                    tSensor = rangeSensor('HorizontalAngleResolution', fDeltaAngle, 'Range', ...
                        [0 afDetectRange(iDetectRange)], 'HorizontalAngle', [0 2*pi]);

                    aafInitPos = GetEntrancePos(iNewDrones, aafEntrancePoint(:,iEntrancePoint));
                    iNumberOfDrones = iNewDrones;
                    atDrones = Drone(iNumberOfDrones);
                    Drone.Init(atDrones, iNumberOfDrones, aafInitPos, fMaxAcc, fMaxVel, ...
                        DroneModelSimple(), ...
                        RangeBearing(afDetectRange(iDetectRange), fDeltaRange, fDeltaAngle), tSensor);

                    [tMap, aaiWalls, fEnvironmentArea] = CreateRoom(csRoomTypes{iRoomType}, ...
                        iRoomsizeX, iRoomsizeY,iPixelPerMeter);
                    tEnvironment = Environment(tMap, fEnvironmentArea, aaiWalls);

                    tController = Controller(csControlTypes{iController}, fGain);

                    %---------- Allocate --------
                    aaafDronePoses = zeros(4,iMaxNumberOfDrones,iNumberOfIterations);
                    aaafU = zeros(2,iMaxNumberOfDrones, iNumberOfIterations);
                    afTotalArea = zeros(iNumberOfIterations,1);

                    %
                    %---------- Simulate --------
                    %Drone.UpdateMeasurements(atDrones, tEnvironment);
                    aaafDronePoses(:,1:iNumberOfDrones,1) = aafInitPos(:,1:iNumberOfDrones);
                    aiDiscoveredWalls = Drone.CalculateInternalBorders(atDrones, tEnvironment);
                    afTotalArea(1) = CalculateArea(atDrones);
                    iPercent = 1;

                    for iTime = 2:iNumberOfIterations

                        aaafU(:,1:iNumberOfDrones,iTime) = tController.Actuation(atDrones);
                        % check if new drone should enter
                        if all(sum((aaafDronePoses(1:2,1:iNumberOfDrones,iTime-1)-aafEntrancePoint(:,iEntrancePoint)).^2,1) > 0.55*afDetectRange(iDetectRange)^2)
                            if iNumberOfDrones <= iMaxNumberOfDrones - iNewDrones
                                aafNewPoses = GetEntrancePos(iNewDrones,aafEntrancePoint(:,iEntrancePoint));
                                atDrones = Drone.EnterNewDrone(atDrones,iNewDrones, aafNewPoses);
                                iNumberOfDrones = iNumberOfDrones+iNewDrones;
                            end
                        end % end check for entering new drone

                        aaafDronePoses(:,1:iNumberOfDrones,iTime) = Drone.ActuateAll(atDrones, aaafU(:,1:iNumberOfDrones,iTime), fTimestep);

                        aiDiscoveredWalls = Drone.CalculateInternalBorders(atDrones, tEnvironment);
                        afTotalArea(iTime) = CalculateArea(atDrones);

                        if CheckTermination(aaafDronePoses, iTime, fTerminationEpsilon, iStepsForTermination)
                            break;
                        end

                        if bPlotSim
                            tEnvironment.Plot(atDrones);
                        end
                        
                        if afTotalArea(iTime) >= (iPercent*0.05)*fEnvironmentArea
                            aaaaaaiTimeOfPercentageCoverage(iPercent, iRoomType, iController, ...
                                iEntrancePoint, iNewDrones, iDetectRange) = iTime;
                            aaaaaaiNumberOfDrones(iPercent, iRoomType, iController, ...
                                iEntrancePoint, iNewDrones, iDetectRange) = iNumberOfDrones;
                            iPercent = iPercent + 1;
                        end
                        
                    end

                    %---Store results
%                     for iPercent = 1:19
%                         iTimeOfCoverage = find(afTotalArea > (iPercent*0.05)*fEnvironmentArea,1);
%                         if ~isempty(iTimeOfCoverage)
%                             aaaaaaiTimeOfPercentageCoverage(iPercent, iRoomType, iController, ...
%                                 iEntrancePoint, iNewDrones, iDetectRange) = iTimeOfCoverage;
%                         end
%                     end            
%                     aaaaaaiNumberOfDrones(iRoomType, iController, ...
%                         iEntrancePoint, iNewDrones, iDetectRange) = iNumberOfDrones;
                    aaaaaaiNumberOfDrones(20, iRoomType, iController, ...
                        iEntrancePoint, iNewDrones, iDetectRange) = iNumberOfDrones;
                    aaaaaiFinalAreaCoverage(iRoomType, iController, ...
                        iEntrancePoint, iNewDrones, iDetectRange) = afTotalArea(iTime);

                    PlotAndSave(csRoomTypes{iRoomType}, 0, ...
                        csControlTypes{iController}, aafEntrancePoint(:,iEntrancePoint) , int2str(iNewDrones), ...
                        int2str(afDetectRange(iDetectRange)), afTotalArea(1:iTime), tEnvironment,...
                        atDrones, int2str(fGain));
                    %EstimationMovie(csRoomTypes{iRoomType}, csControlTypes{iController}, 'Corner', '3', ...
                    %    tEnvironment, aaafDronePoses(:,1:iNumberOfDrones,1:iTime),...
                    %    atDrones(1).tSensor.Range(2), afTotalArea(1:iTime))

%                     save(strcat(savefile,'_TimeOfPercentageCoverage'), 'aaaaaaiTimeOfPercentageCoverage');
%                     save(strcat(savefile,'_NumberOfDrones'), 'aaaaaiFinalNumberOfDrones');
%                     save(strcat(savefile,'_AreaCovered'), 'aaaaaiFinalAreaCoverage');
                    save(strcat(savefile, '_Time_Drones_Area'), 'aaaaaaiTimeOfPercentageCoverage', 'aaaaaaiNumberOfDrones',...
                        'aaaaaiFinalAreaCoverage');
                end % end for fDetectRange
            end %numberOfNewDrones
        end %end entrancepoint
    end %end control law
end %end room shape
toc             
%%





